//    ++    Arduino 1.6.7.   :
#include "Arduino.h"   
#if !defined(SERIAL_PORT_MONITOR)
  #error "  Arduino  .     IDE."
#endif
#if defined(SERIAL_PORT_USBVIRTUAL)
  #define port SERIAL_PORT_HARDWARE
  #define pcSerial SERIAL_PORT_USBVIRTUAL
#else
  //  Jumper  SW (  12/13  8/9  RX/TX)
  #include "SoftwareSerial.h"
  SoftwareSerial port(12, 13);
  #define pcSerial SERIAL_PORT_MONITOR
#endif
#include "EasyVR.h"   //  "EasyVR"
EasyVR easyvr(port);
// Groups  Commands
enum Groups
{
     GROUP_3  = 3,  //     
};
enum Group3 
{
  // :
     G2_ON1 = 0,
     G2_ON2 = 1,
     G2_ON3 = 2,
     G2_ON4 = 3,
     G2_OFF1 = 4,
     G2_OFF2 = 5,
     G2_OFF3 = 6,
     G2_OFF4 = 7,
     G2_ONOLL = 8,
     G2_OFFOLL = 9,
 };
int8_t group3, idx;
void setup()
{
  //    PC
  pcSerial.begin(9600);
  pinMode(8, OUTPUT);
  pinMode(9, OUTPUT);
  pinMode(10, OUTPUT);
  pinMode(11, OUTPUT);
  pinMode(13, OUTPUT);
  //  ?
  int mode = easyvr.bridgeRequested(pcSerial);
  switch (mode)
  {
     case EasyVR::BRIDGE_NONE:
       // //    EasyVR 
       port.begin(9600);
       //    normally
       pcSerial.println(F("---"));
       pcSerial.println(F("  !"));
       break; 
  case EasyVR::BRIDGE_NORMAL:
       // setup EasyVR serial port (low speed)
       port.begin(9600);
       //   2  (PC  EasyVR)
       easyvr.bridgeLoop(pcSerial);
       //  
       pcSerial.println(F("---"));
       pcSerial.println(F("  !"));
       break;    
  case EasyVR::BRIDGE_BOOT:
       // //    EasyVR (. )
       port.begin(115200);
       //   2  (PC  EasyVR)
       easyvr.bridgeLoop(pcSerial);
       //  
       pcSerial.println(F("---"));
       pcSerial.println(F("  !"));
       break;
  }
  while (!easyvr.detect())
  {
       Serial.println("EasyVR  !");
       delay(1000);
  }
  easyvr.setPinOutput(EasyVR::IO1, LOW);
  Serial.println("EasyVR !");
  easyvr.setTimeout(5);
  easyvr.setLanguage(0);
  group3 = GROUP_3;
   //<--   ()
}
void action();
void loop()
{
     easyvr.setPinOutput(EasyVR::IO1, HIGH); //  . ()
     Serial.print("    ... ");
     Serial.println(group3);
     easyvr.recognizeCommand(group3);  
  do
  {
    //    -,     ...
  }
  while (!easyvr.hasFinished());  
  easyvr.setPinOutput(EasyVR::IO1, LOW); //  .
  idx = easyvr.getWord();
  if (idx >= 0)
  {
     group3 = GROUP_3;     
    // group = GROUP_X; <--     (X)
    return;
  }
  idx = easyvr.getCommand();
  if (idx >= 0)
  {
       //    ()
       uint8_t train = 0;
       char name[32];
       Serial.print(": ");
       Serial.print(idx);
       if (easyvr.dumpCommand(group3, idx, name, train))
       {
            Serial.print(" = ");
            Serial.println(name);
       }
       else
       {
            Serial.println();
       }
       easyvr.playSound(0, EasyVR::VOL_FULL);
       //   
       action();    
  }
  else //    ( )
  {
    if (easyvr.isTimeout())
      Serial.println("   --,  2,   ...");
    int16_t err = easyvr.getError();
    if (err >= 0)
    {
         Serial.print(" ");
         Serial.println(err, HEX);
    }
  }
}
void action()
{
   switch (group3)
    {
    case GROUP_3:
      switch (idx)
      {
      case G2_ON1:
           //    1
           // group = GROUP_X; <--      (X)   
           digitalWrite(8, HIGH); //     1
           break;        
      case G2_ON2:
           //    2
           // group = GROUP_X; <--      (X)   
           digitalWrite(9, HIGH); //     2
           break;      
      case G2_ON3:
           //    3
           // group = GROUP_X; <--      (X)   
           digitalWrite(10, HIGH); //     3
           break;
      case G2_ON4:
           //    4
           // group = GROUP_X; <--      (X)   
           digitalWrite(11, HIGH); //     4
           break;

      case G2_OFF1:
           //    5
           // group = GROUP_X; <--      (X)   
           digitalWrite(8, LOW); //     5
           break;      
      case G2_OFF2:
           //    6
           // group = GROUP_X; <--      (X)   
           digitalWrite(9, LOW); //     6
           break;      
      case G2_OFF3:
           //    7
           // group = GROUP_X; <--      (X)   
           digitalWrite(10, LOW); //     7
           break;
      case G2_OFF4:
           //    8
           // group = GROUP_X; <--      (X)   
           digitalWrite(11, LOW); //     8
           break;
      case G2_ONOLL:
           //    9
           // group = GROUP_X; <--      (X)   
           //     9:
           digitalWrite(8, HIGH);
           digitalWrite(9, HIGH);
           digitalWrite(10, HIGH);
           digitalWrite(11, HIGH);
           break;        
      case G2_OFFOLL:
           //    10
           // group = GROUP_X; <--      (X)   
           //     10:
           digitalWrite(8, LOW);
           digitalWrite(9, LOW);
           digitalWrite(10, LOW);
           digitalWrite(11, LOW);
           break;        
      }
    }
	}
